<?php
/*##################################################
 *                    SeriesCommentsTopic.class.php
 *                            -------------------
 *   begin                : March 14, 2013
 *   copyright            : (C) 2014 Root
 *   email                : contact@graphismeo.ovh
 *
 *
 ###################################################
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 ###################################################*/

/**
 * @author Patrick DUBEAU <daaxwizeman@gmail.com>
 */
class SeriesCommentsTopic extends CommentsTopic
{
	private $serie;
	
	public function __construct(Serie $serie = null)
	{
		parent::__construct('series');
		$this->serie = $serie;
	}
	
	public function get_authorizations()
	{
		$authorizations = new CommentsAuthorizations();
		$authorizations->set_authorized_access_module(SeriesAuthorizationsService::check_authorizations($this->get_serie()->get_id_category())->read());
		return $authorizations;
	}
	
	public function is_display()
	{
		return $this->get_serie()->is_published();
	}
	
	private function get_serie()
	{
		if ($this->serie === null)
		{
			$this->serie = SeriesService::get_serie('WHERE series.id=:id', array('id' => $this->get_id_in_module()));
		}
		return $this->serie;
	}
}
?>