<?php
/*##################################################
 *		    SeriesTreeLinks.class.php
 *                            -------------------
 *   begin                : November 29, 2013
 *   copyright            : (C) 2014 Root
 *   email                : contact@graphismeo.ovh
 *
 *
 ###################################################
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 ###################################################*/

/**
 * @author Patrick DUBEAU <daaxwizeman@gmail.com>
 */
class SeriesTreeLinks implements ModuleTreeLinksExtensionPoint
{
	public function get_actions_tree_links()
	{
		$lang = LangLoader::get('common', 'series');
		$tree = new ModuleTreeLinks();
		
		$manage_categories_link = new AdminModuleLink(LangLoader::get_message('categories.manage', 'categories-common'), SeriesUrlBuilder::manage_categories());
		$manage_categories_link->add_sub_link(new AdminModuleLink(LangLoader::get_message('categories.manage', 'categories-common'), SeriesUrlBuilder::manage_categories()));
		$manage_categories_link->add_sub_link(new AdminModuleLink(LangLoader::get_message('category.add', 'categories-common'), SeriesUrlBuilder::add_category()));
		$tree->add_link($manage_categories_link);
	
		$manage_series_link = new AdminModuleLink($lang['series_management'], SeriesUrlBuilder::manage_series());
		$manage_series_link->add_sub_link(new AdminModuleLink($lang['series_management'], SeriesUrlBuilder::manage_series()));
		$manage_series_link->add_sub_link(new AdminModuleLink($lang['series.add'], SeriesUrlBuilder::add_serie(AppContext::get_request()->get_getstring('id_category', 0))));
		$tree->add_link($manage_series_link);
		
		$tree->add_link(new AdminModuleLink(LangLoader::get_message('configuration', 'admin'), SeriesUrlBuilder::series_configuration()));

		if (!AppContext::get_current_user()->check_level(User::ADMIN_LEVEL))
		{
			$tree->add_link(new ModuleLink($lang['series.add'], SeriesUrlBuilder::add_serie(AppContext::get_request()->get_getstring('id_category', 0)), SeriesAuthorizationsService::check_authorizations()->write() || SeriesAuthorizationsService::check_authorizations()->contribution()));	
		}

		$tree->add_link(new ModuleLink($lang['series.pending_series'], SeriesUrlBuilder::display_pending_series(), SeriesAuthorizationsService::check_authorizations()->write() || SeriesAuthorizationsService::check_authorizations()->contribution() || SeriesAuthorizationsService::check_authorizations()->moderation()));
	
		return $tree;
	}
}
?>
