<?php
/*##################################################
 *                     AdminSeriesDisplayResponse.class.php
 *                            -------------------
 *   begin                : March 27, 2013
 *   copyright            : (C) 2014 Root
 *   email                : contact@graphismeo.ovh
 *
 *
 ###################################################
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 ###################################################*/

/**
 * @author Patrick DUBEAU <daaxwizeman@gmail.com>
 */
class AdminSeriesDisplayResponse extends AdminMenuDisplayResponse
{
	public function __construct($view, $title_page)
	{
		parent::__construct($view);
		
		$lang = LangLoader::get('common', 'series');
		$this->set_title($lang['series']);
		$img = 'series.png';
		
		$this->add_link(LangLoader::get_message('categories.management', 'categories-common'), SeriesUrlBuilder::manage_categories(), $img);
		$this->add_link(LangLoader::get_message('category.add', 'categories-common'), SeriesUrlBuilder::add_category(), $img);
		$this->add_link($lang['series_management'], SeriesUrlBuilder::manage_series(), $img);
		$this->add_link($lang['series.add'], SeriesUrlBuilder::add_serie(Category::ROOT_CATEGORY), $img);
		$this->add_link(LangLoader::get_message('configuration', 'admin'), SeriesUrlBuilder::series_configuration(), $img);
		
		$env = $this->get_graphical_environment();
		$env->set_page_title($title_page);
	}
}
?>